AirlinesWeb/Models/Airline.cs
using System;
using System.ComponentModel.DataAnnotations;
using System.Globalization;

namespace AirlinesWeb.Models
{
    #pragma warning disable CS8618 
    public class Airline
    {
        public int Id { get; set; }

        [Required(ErrorMessage = "Name is required")]
        public string Name { get; set; }

        [Required(ErrorMessage = "Founded date is required")]
        public DateTime Founded { get; set; }

        [Required(ErrorMessage = "Fleet size is required")]
        [Range(1, int.MaxValue, ErrorMessage = "Fleet size must be a positive number")]
        public int FleetSize { get; set; }

        [Required(ErrorMessage = "Description is required")]
        public string Description { get; set; }
    }
}

AirlinesWeb/Models/Airport.cs
using System;
using System.ComponentModel.DataAnnotations;
using System.Globalization;

namespace AirlinesWeb.Models;

public class Airport
{
    public int Id { get; set; }

    [Required(ErrorMessage = "Name is required")]
    public string AirportName { get; set; } = null!;

    [Required(ErrorMessage = "Country is required")]
    public string Country { get; set; } = null!;

    [Required(ErrorMessage = "City is required")]
    public string City { get; set; } = null!;

    [Required(ErrorMessage = "Code is required")]
    public string Code { get; set; } = null!;

    [Required(ErrorMessage = "RunwaysCount is required")]
    public int RunwaysCount { get; set; }

    [Required(ErrorMessage = "Founded is required")]
    public DateTime Founded { get; set; }
}

AirlinesWeb/Models/ErrorViewModel.cs
namespace AirlinesWeb.Models;

public class ErrorViewModel
{
    public string? RequestId { get; set; }

    public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
}

AirlinesWeb/Models/Flight.cs
using System;
using System.ComponentModel.DataAnnotations;
using System.Globalization;

namespace AirlinesWeb.Models;

public class Flight
{
    public int Id { get; set; }

    [Required(ErrorMessage = "FlightNumber is required")]
    public string FlightNumber { get; set; } = null!;

    [Required(ErrorMessage = "FromAirportId is required")]
    public int FromAirportId { get; set; }

    [Required(ErrorMessage = "ToAirportId is required")]
    public int ToAirportId { get; set; }

    [Required(ErrorMessage = "AircraftModelId is required")]
    public int AircraftModelId { get; set; }

    [Required(ErrorMessage = "Price is required")]
    public decimal Price { get; set; }

    [Required(ErrorMessage = "Duration is required")]
    public double Duration { get; set; }

    [Required(ErrorMessage = "DepartureDatetime is required")]
    public DateTime DepartureDatetime { get; set; }

    [Required(ErrorMessage = "ArrivalDatetime is required")]
    public DateTime ArrivalDatetime { get; set; }

    [Required(ErrorMessage = "AirlineId is required")]
    public int AirlineId { get; set; }
}

AirlinesWeb/Controllers/AirlineController.cs
using Microsoft.AspNetCore.Mvc;
using AirlinesWeb.Models;
using AirlinesWeb.Mappers;
using Airlines.Business.Service;

namespace AirlinesWeb.Controllers;

public class AirlineController : Controller
{

    // GET: AirlineController
    public ActionResult Index()
    {
        List<Airline> _airlines = new List<Airline>();

        var airlineDTOs = AirlineService.GetAirlinesFromDB();
        foreach (var airlineDTO in airlineDTOs)
        {
            _airlines.Add(airlineDTO.ToModel());
        }
        return View(_airlines);
    }

    // POST: AirlineController
    [HttpPost]
    [ValidateAntiForgeryToken]
    public ActionResult Create(Airline airline)
    {
        try
        {
            var success = AirlineService.AddAirlineToDB(airline.ToDTO());
            if (!success)
            {
                System.Console.WriteLine("Error!");
                throw new Exception();
            }
            return RedirectToAction(nameof(Index));
        }
        catch
        {
            return RedirectToAction(nameof(Index));
        }
    }

    // GET: AirlineSearch
    public ActionResult Search(string searchText, string filterCriteria)
    {
        List<Airline> _airlines = new List<Airline>();

        if (string.IsNullOrEmpty(searchText))
            return RedirectToAction(nameof(Index));

        var airlineDTOs = AirlineService.SearchAirlinesInDB(searchText, filterCriteria);
        foreach (var airlineDTO in airlineDTOs)
        {
            _airlines.Add(airlineDTO.ToModel());
        }
        return View("Index", _airlines);
    }

}

AirlinesWeb/Controllers/AirportController.cs
using Microsoft.AspNetCore.Mvc;
using AirlinesWeb.Models;
using AirlinesWeb.Mappers;
using Airlines.Business.Service;

namespace AirlinesWeb.Controllers;

public class AirportController : Controller
{

    // GET: AirportController
    public ActionResult Index()
    {
        List<Airport> _airports = new List<Airport>();
        
        var airportDTOs = AirportService.GetAirportsFromDB();
        foreach (var airportDTO in airportDTOs)
        {
            _airports.Add(airportDTO.ToModel());
        }
        return View(_airports);
    }

    // POST: AirportController
    [HttpPost]
    // [ValidateAntiForgeryToken]
    public ActionResult Create(Airport airport)
    {
        try
        {
            var success = AirportService.AddAirportToDB(airport.ToDTO());
            if (!success)
            {
                System.Console.WriteLine("Error!");
                throw new Exception();
            }
            return RedirectToAction(nameof(Index));
        }
        catch
        {
            return RedirectToAction(nameof(Index));
        }
    }

    // GET: AirportSearch
    public ActionResult Search(string searchText, string filterCriteria)
    {
        List<Airport> _airports = new List<Airport>();

        if (string.IsNullOrEmpty(searchText))
            return RedirectToAction(nameof(Index));

        var airportDTOs = AirportService.SearchAirportsInDB(searchText, filterCriteria);
        foreach (var airportDTO in airportDTOs)
        {
            _airports.Add(airportDTO.ToModel());
        }
        return View("Index", _airports);
    }
}

AirlinesWeb/Controllers/FlightController.cs
using Microsoft.AspNetCore.Mvc;
using AirlinesWeb.Models;
using AirlinesWeb.Mappers;
using Airlines.Business.Service;

namespace AirlinesWeb.Controllers;

public class FlightController : Controller
{

    // GET: FlightController
    public ActionResult Index()
    {
        List<Flight> _flights = new List<Flight>();

        var flightDTOs = FlightService.GetFlightsFromDB();
        foreach (var flightDTO in flightDTOs)
        {
            _flights.Add(flightDTO.ToModel());
        }
        return View(_flights);
    }

    // POST: FlightController
    [HttpPost]
    // [ValidateAntiForgeryToken]
    public ActionResult Create(Flight flight)
    {
        try
        {
            var success = FlightService.AddFlightToDB(flight.ToDTO());
            if (!success)
            {
                System.Console.WriteLine("Error!");
                throw new Exception();
            }
            return RedirectToAction(nameof(Index));
        }
        catch
        {
            return RedirectToAction(nameof(Index));
        }
    }

    // GET: FlightSearch
    public ActionResult Search(string searchText, string filterCriteria)
    {
        List<Flight> _flights = new List<Flight>();

        if (string.IsNullOrEmpty(searchText))
            return RedirectToAction(nameof(Index));

        var flightDTOs = FlightService.SearchFlightsInDB(searchText, filterCriteria);
        foreach (var flightDTO in flightDTOs)
        {
            _flights.Add(flightDTO.ToModel());
        }
        return View("Index", _flights);
    }
}

AirlinesWeb/Controllers/HomeController.cs
using System.Diagnostics;
using Microsoft.AspNetCore.Mvc;
using AirlinesWeb.Models;
using Airlines.Business.Service;

namespace AirlinesWeb.Controllers;

public class HomeController : Controller
{
    private readonly ILogger<HomeController> _logger;

    public HomeController(ILogger<HomeController> logger)
    {
        _logger = logger;
    }

    public IActionResult Index()
    {
        var airlinesCount = AirlineService.GetAirlinesCountFromDB();
        var airportsCount = AirportService.GetAirportsCountFromDB();
        var flightsCount = FlightService.GetFlightsCountFromDB();

        ViewBag.AirlinesCount = airlinesCount!;
        ViewBag.AirportsCount = airportsCount!;
        ViewBag.FlightsCount = flightsCount!;

        return View();
    }

    public IActionResult Privacy()
    {
        return View();
    }

    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    public IActionResult Error()
    {
        return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
    }
}

AirlinesWeb/Views/Airline/index.cshtml
@model IEnumerable<AirlinesWeb.Models.Airline>

@{
    ViewData["Title"] = "View";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<main class="content">
    <button id="scrollToTopBtn">↑</button>
    <div class="title">
        <a asp-area="" asp-controller="Home" asp-action="Index"><img src="~/assets/left sidebar.png" alt=""></a>
        <h2>Airlines</h2>
    </div>
    <hr>
    <div class="container">
        <form asp-controller="Airline" asp-action="Search" id="searchForm">
            <input type="text" id="searchInput" name="searchText" placeholder="Search...">
            <select id="filterDropdown" name="filterCriteria">
                <option value="Name">Name</option>
                <option value="Founded">Founded</option>
                <option value="FleetSize">FleetSize</option>
                <option value="Description">Description</option>
            </select>
            <button id="searchButton" type="submit">Search</button>
        </form>
    </div>
    <div class="table fade-in">
        <table>
            <thead>
                <tr>
                    <th>
                        @Html.DisplayNameFor(model => model.Name)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.Founded)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.FleetSize)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.Description)
                    </th>
                </tr>
            </thead>
            <tbody>
                @foreach (var item in Model)
                {
                    <tr>
                        <td>
                            @Html.DisplayFor(modelItem => item.Name)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.Founded)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.FleetSize)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.Description)
                        </td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
    <div class="showFormButton">
        <button id="showMoreButton">Show more</button>
        <button id="showFormButton">Show Form</button>
    </div>
    <div class="form fade-in" id="formSection">
        <form asp-controller="Airline" asp-action="Create" id="flightForm" method="post">
            <fieldset>
                <legend>Add New Airline</legend>

                <label for="Name">Name:</label>
                <input type="text" id="name" name="Name" required />
                <span id="nameError" class="error"></span>

                <label for="Founded">Founded:</label>
                <input type="datetime-local" id="founded" name="Founded" required />
                <span id="foundedError" class="error"></span>

                <label for="FleetSize">Fleet size:</label>
                <input type="number" id="fleet_size" name="FleetSize" required />
                <span id="fleetSizeError" class="error"></span>

                <label for="Description">Description:</label>
                <input type="text" id="description" name="Description" required />
                <span id="descriptionError" class="error"></span>

                <button type="submit" id="submitButton" disabled>Submit</button>
            </fieldset>
        </form>
    </div>
    <div style="height: 2000px;">Scroll down to see the button in action!</div>
</main>
<script defer src="~/js/validation.js"></script>
<script defer src="~/js/animation.js"></script>

AirlinesWeb/Views/Airport/index.cshtml
@model IEnumerable<AirlinesWeb.Models.Airport>


@{
    ViewData["Title"] = "View";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<main class="content">
    <button id="scrollToTopBtn">↑</button>
    <div class="title">
        <a asp-area="" asp-controller="Home" asp-action="Index"><img src="~/assets/left sidebar.png" alt=""></a>
        <h2>Airports</h2>
    </div>
    <hr>
    <div class="container">
        <form asp-controller="Airport" asp-action="Search" id="searchForm">
            <input type="text" id="searchInput" name="searchText" placeholder="Search...">
            <select id="filterDropdown" name="filterCriteria">
                <option value="AirportName">AirportName</option>
                <option value="Country">Country</option>
                <option value="City">City</option>
                <option value="Code">Code</option>
                <option value="RunwaysCount">RunwaysCount</option>
                <option value="Founded">Founded</option>
            </select>
            <button id="searchButton" type="submit">Search</button>
        </form>
    </div>
    <div class="table fade-in">
        <table>
            <thead>
                <tr>
                    <th>
                        @Html.DisplayNameFor(model => model.AirportName)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.Country)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.City)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.Code)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.RunwaysCount)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.Founded)
                    </th>
                </tr>
            </thead>
            <tbody>
                @foreach (var item in Model)
                {
                    <tr>
                        <td>
                            @Html.DisplayFor(modelItem => item.AirportName)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.Country)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.City)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.Code)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.RunwaysCount)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.Founded)
                        </td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
    <div class="showFormButton">
        <button id="showMoreButton">Show more</button>
        <button id="showFormButton">Show Form</button>
    </div>
    <div class="form fade-in" id="formSection">
        <form asp-controller="Airport" asp-action="Create" id="flightForm" method="post">
            <fieldset>
                <legend>Add New Airport</legend>

                <label for="AirportName">Name:</label>
                <input type="text" id="name" name="AirportName" required />
                <span id="nameError" class="error"></span>

                <label for="Country">Country:</label>
                <input type="text" id="country" name="Country" required />
                <span id="countryError" class="error"></span>

                <label for="City">City:</label>
                <input type="text" id="city" name="City" required />
                <span id="cityError" class="error"></span>

                <label for="Code">Code:</label>
                <input type="text" id="code" name="Code" required />
                <span id="codeError" class="error"></span>

                <label for="RunwaysCount">Runways count:</label>
                <input type="number" id="runways_count" name="RunwaysCount" required />
                <span id="runwaysCountError" class="error"></span>

                <label for="Founded">Founded:</label>
                <input type="datetime-local" id="founded" name="Founded" required />
                <span id="foundedError" class="error"></span>

                <button type="submit" id="submitButton" disabled >Submit</button>
            </fieldset>
        </form>
    </div>
    <div style="height: 2000px;">Scroll down to see the button in action!</div>
</main>
<script defer src="~/js/validation.js"></script>
<script defer src="~/js/animation.js"></script>

AirlinesWeb/Views/Flight/index.cshtml
@model IEnumerable<AirlinesWeb.Models.Flight>

@{
    ViewData["Title"] = "View";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<main class="content">
    <button id="scrollToTopBtn">↑</button>
    <div class="title">
        <a asp-area="" asp-controller="Home" asp-action="Index"><img src="~/assets/left sidebar.png" alt=""></a>
        <h2>Flights</h2>
    </div>
    <hr>
    <div class="container">
        <form asp-controller="Flight" asp-action="Search" id="searchForm">
            <input type="text" id="searchInput" name="searchText" placeholder="Search...">
            <select id="filterDropdown" name="filterCriteria">
                <option value="FlightNumber">FlightNumber</option>
                <option value="FromAirportId">FromAirportId</option>
                <option value="ToAirportId">ToAirportId</option>
                <option value="AircraftModelId">AircraftModelId</option>
                <option value="Price">Price</option>
                <option value="Duration">Duration</option>
                <option value="DepartureDatetime">DepartureDatetime</option>
                <option value="ArrivalDatetime">ArrivalDatetime</option>
                <option value="AirlineId">AirlineId</option>
            </select>
            <button id="searchButton" type="submit">Search</button>
        </form>
    </div>
    <div class="table fade-in">
        <table>
            <thead>
                <tr>
                    <th>
                        @Html.DisplayNameFor(model => model.FlightNumber)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.FromAirportId)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.ToAirportId)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.AircraftModelId)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.Price)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.Duration)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.DepartureDatetime)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.ArrivalDatetime)
                    </th>
                    <th>
                        @Html.DisplayNameFor(model => model.AirlineId)
                    </th>
                </tr>
            </thead>
            <tbody>
                @foreach (var item in Model)
                {
                    <tr>
                        <td>
                            @Html.DisplayFor(modelItem => item.FlightNumber)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.FromAirportId)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.ToAirportId)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.AircraftModelId)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.Price)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.Duration)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.DepartureDatetime)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.ArrivalDatetime)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.AirlineId)
                        </td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
    <div class="showFormButton">
        <button id="showMoreButton">Show more</button>
        <button id="showFormButton">Show Form</button>
    </div>
    <div class="form fade-in" id="formSection">
        <form asp-controller="Flight" asp-action="Create" id="flightForm" method="post">
            <fieldset>
                <legend>Add New Flight</legend>

                <label for="FlightNumber">Flight number:</label>
                <input type="text" id="flight_number" name="FlightNumber" required />
                <span id="flightNumberError" class="error"></span>

                <label for="FromAirportId">From:</label>
                <input type="number" id="from" name="FromAirportId" required />
                <span id="fromAirportIdError" class="error"></span>

                <label for="ToAirportId">To:</label>
                <input type="number" id="to" name="ToAirportId" required />
                <span id="toAirportIdError" class="error"></span>

                <label for="AircraftModelId">Aircraft model id:</label>
                <input type="number" id="aircraft_model_id" name="AircraftModelId" required />
                <span id="aircraftModelIdError" class="error"></span>

                <label for="Price">Price:</label>
                <input type="number" id="price" name="Price" required />
                <span id="priceError" class="error"></span>

                <label for="Duration">Duration:</label>
                <input type="number" id="duration" name="Duration" required />
                <span id="durationError" class="error"></span>

                <label for="DepartureDatetime">Departure datetime:</label>
                <input type="datetime-local" id="departure_datetime" name="DepartureDatetime" required />
                <span id="departureDatetimeError" class="error"></span>

                <label for="ArrivalDatetime">Arrival datetime:</label>
                <input type="datetime-local" id="arrival_datetime" name="ArrivalDatetime" required />
                <span id="arrivalDatetimeError" class="error"></span>

                <label for="AirlineId">Airline id:</label>
                <input type="number" id="airline_id" name="AirlineId" required />
                <span id="airlineIdError" class="error"></span>

                <button type="submit" id="submitButton" disabled >Submit</button>
            </fieldset>
        </form>
    </div>
    <div style="height: 2000px;">Scroll down to see the button in action!</div>
</main>
<script defer src="~/js/validation.js"></script>
<script defer src="~/js/animation.js"></script>

AirlinesWeb/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<main class="HomeContent">
    <h1>Welcome To Dashboard</h1>
    <div class="dashboard">
        <div class="info">
            <div>
                <h2>Airports</h2>
                <img src="~/assets/mdi_airport.png" alt="airport">
                <h2>@ViewBag.AirportsCount</h2>
            </div>
            <button>
                <a asp-area="" asp-controller="Airport" asp-action="Index">Add New Airport</a>
            </button>
        </div>
        <div class="info">
            <div>
                <h2>Airlines</h2>
                <img src="~/assets/ri_plane-fill.png" alt="airline">
                <h2>@ViewBag.AirlinesCount</h2>
            </div>
            <button>
                <a asp-area="" asp-controller="Airline" asp-action="Index">Add New Airline</a>
            </button>
        </div>
        <div class="info">
            <div>
                <h2>Flights</h2>
                <img src="~/assets/carbon_flight-schedule.png" alt="flights">
                <h2>@ViewBag.FlightsCount</h2>
            </div>
            <button>
                <a asp-area="" asp-controller="Flight" asp-action="Index">Add New Flight</a>
            </button>
        </div>
    </div>
</main>

AirlinesWeb/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="~/css/styles.css" asp-append-version="true">
    <title>Rise Airlines</title>
</head>

<body>
    <header class="navbar">
        <h1><a asp-area="" asp-controller="Home" asp-action="Index">Rise Airlines</a> <img
                src="~/assets/header-plane.png" alt="plane"></h1>
        <partial name="_Navigation"/>
    </header>
    <main>
        @RenderBody()
    </main>
    <footer class="footer">
        <p>Rise Airlines 2024 &copy;</p>
    </footer>
</body>

</html>

AirlinesWeb/Views/Shared/_Navigation.cshtml
<nav>
    <ul>
        <li><a href="@Url.Action("Index", "Airport")"
                class="@((ViewContext.RouteData.Values["controller"] as string == "Airport" && ViewContext.RouteData.Values["action"] as string == "Index") ? "active" : "")">Airports</a>
        </li>
        <li><a href="@Url.Action("Index", "Airline")"
                class="@((ViewContext.RouteData.Values["controller"] as string == "Airline" && ViewContext.RouteData.Values["action"] as string == "Index") ? "active" : "")">Airlines</a>
        </li>
        <li><a href="@Url.Action("Index", "Flight")"
                class="@((ViewContext.RouteData.Values["controller"] as string == "Flight" && ViewContext.RouteData.Values["action"] as string == "Index") ? "active" : "")">Flights</a>
        </li>
    </ul>
</nav>